Index: /anuga_core/documentation/user_manual/anuga_installation_guide.tex
===================================================================
--- /anuga_core/documentation/user_manual/anuga_installation_guide.tex	(revision 3887)
+++ /anuga_core/documentation/user_manual/anuga_installation_guide.tex	(revision 3888)
@@ -46,25 +46,74 @@
 
 
+\section{Quick install (Windows only)}
+
+This section provides the quickest path to getting ANUGA up and running on a Windows machine. 
+For Linux and for more details please refer to Section \ref{sec:prerequisites}.
+
+\begin{enumerate}  
+  \item Download and install the Enthought version of Python2.4 from \url{http://code.enthought.com/enthon/}.
+  \item Add the following to the PATH environment variable
+    \begin{verbatim}
+      PATH=C:\Python24;C:\Python24\Enthought\MingW\bin;C:\Program Files\anuga_viewer
+    \end{verbatim} 
+  \item Unpack the ANUGA source code (anuga.tgz) in the python site-packages 
+  directory (C:\Python24\Lib\site-packages)
+  \item In the ANUGA root directory (C:\Python24\Lib\site-packages\anuga), run the compilation script:
+    {\small \begin{verbatim}
+	python compile_all.py
+    \end{verbatim}}
+  \item In the ANUGA root directory, run the test suite:
+    {\small \begin{verbatim}
+	python test_all.py
+    \end{verbatim}}
+    ANUGA has been succesfully installed if the tests pass.
+\end{enumerate}   
+
+To install the anuga\_viewer
+\begin{enumerate} 
+  \item Unpack the distribution () in 
+    \begin{verbatim} 
+      C:\Program Files\anuga_viewer
+    \end{verbatim}
+  \item Associate .sww files with the executable
+  \begin{verbatim} 
+    C:\Program Files\anuga_viewer\animate.exe
+  \end{verbatim}        
+  \item Double click on the test file 
+    \begin{verbatim} 
+      C:\Program Files\anuga_viewer\cylinders.sww
+    \end{verbatim}        
+\end{enumerate} 
+
+Try the demos provided in the ANUGA root directory (also discussed in the ANUGA user manual 
+\url{http://datamining.anu.edu.au/~ole/anuga/user_manual/anuga_user_manual.pdf}) and 
+view the resulting sww files with the anuga\_viewer.
+
+
+
 \section{Pre-requisites}
-
-The Anuga software core (pyvolution, pmesh, least\_squares, ...) depends on the following:
+\label{sec:prerequisites}
+
+The Anuga software core (shallow\_water, pmesh, least\_squares, ...) depends on the following:
+
 
 \begin{itemize}
-  \item python 2.3 or later \url{http://www.python.org}.  Note, the
-  dll python2X.dll is needed to compile ANUGA, but is not
+  \item python 2.3 or later \url{http://www.python.org}/footnote{Note, the
+  dll python2X.dll is needed to compile ANUGA, but is not always
   automatically added for versions 2.4 and above.  Install it into the
-  python2X directory, if you need it.  
+  python2X directory, if you need it.}.  
   \item python-numeric for Linux.  It's called Numeric in Windows.  
-  \item python-dev (Interestingly, numeric seems to be installed as
-  well) for Linux.  This is not necessary for Windows.
+  %\item python-dev (Interestingly, numeric seems to be installed as
+  %well) for Linux.  This is not necessary for Windows.
   \item python-scientific (to provide python-netcdf) for Linux.  It's
     called ScientificPython in Windows.
-  \item NETCDF.  Extract the file netcdf.dll, and put in C://Windows//System32// (Windows XP) or C://WINNT//System32 (Windows NT or 2000). 
-
+  \item NETCDF.  Extract the file netcdf.dll, and put in C://Windows//System32// (Windows XP) or C://WINNT//System32 (Windows NT or 2000).     
   \item A C compiler such as gcc (from GNU in case of Linux and MinGW
   in case of Windows)
-  \item scons for automatically compiling the distribution.
+  %\item scons for automatically compiling the distribution.
 \end{itemize}
 
+Note: All of these can be installed in one go on Windows platforms by using the Enthought Python 
+distribution available at \url{http://code.enthought.com/enthon/}.
 
 \section{Recommended software}
@@ -72,5 +121,5 @@
 \begin{itemize}
   \item psyco \url{http://psyco.sourceforge.net/index.html}
-  \item visual python \url{http://vpython.org}
+  %\item visual python \url{http://vpython.org}
   \item matplotlib (pylab) for quality 2d plotting (moving towards mandatory requirement)
   \item VTK \url{http://mayavi.sourceforge.net/dwnld/vtk/win32/}
@@ -82,12 +131,14 @@
 
 
-The system path on Win32 architectures must contain the directories
+The system path on Win32 architectures must contain the directories (this examples assumes the 
+Enthought Python 2.4 distribution has been installed. Path names may vary depending on the 
+exact configuration).
 \begin{verbatim}
-  PATH=C:\Python23;C:\MinGW\bin;C:\Program Files\swollen
+  PATH=C:\Python24;C:\Python24\Enthought\MingW\bin;C:\Program Files\anuga_viewer
 \end{verbatim}
-(similar for Linux....)
-
-If anuga is not installed in the python site-packages directory the root directory for all anuga/inundation modules must be on
-the pythonpath, e.g.\
+The path should be analoguous for Unix operating systems.
+
+If anuga is not installed in the python site-packages directory the root directory for all 
+anuga/inundation modules must be on the pythonpath, e.g.\
 \begin{verbatim}
 PYTHONPATH=C:\anuga_core\source
@@ -100,7 +151,7 @@
 \section{Installation of source zip file}
 Get a source zip file, for example, anuga_source_3807.zip, and expand
-it in the python site-packages directory. 
-
-In the ANUGA root directory, run the compilation script:
+it in the python site-packages directory (C:\Python24\Lib\site-packages)
+
+In the ANUGA root directory (C:\Python24\Lib\site-packages\anuga), run the compilation script:
 {\small \begin{verbatim}
   python compile_all.py
@@ -118,19 +169,40 @@
   python test_all.py
 \end{verbatim}}
-
-
-
-
-\section{Other stuff to be included}
-
+ANUGA has been succesfully installed if the tests pass as follows:
+
+{\tiny
 \begin{verbatim}
-Install tortoise from downloads (ITs didn't integrate wih explorer).
-In settings set proxy to proxy.agso.gov.au  8080
-
-
-Install swollen from latest distro (in subversion)
-
-
-\end{verbatim}
+  ...
+  test_data_manager.py
+  test_interpolate_sww.py
+  test_mesh.py
+  test_mesh_interface.py
+  test_triangmodule.py
+  test_triangmoduleII.py
+  test_advection.py
+............................................................................................................................................
+............................................................................................................................................
+............................................................................................................................................
+............................................................................................................................................
+.................................
+----------------------------------------------------------------------
+Ran 593 tests in 42.712s
+
+OK
+\end{verbatim} }
+
+
+
+%\section{Other stuff to be included}
+%
+%\begin{verbatim}
+%Install tortoise from downloads (ITs didn't integrate wih explorer).
+%In settings set proxy to proxy.agso.gov.au  8080
+%%
+%
+%Install swollen from latest distro (in subversion)
+%
+%
+%\end{verbatim}
 
 